﻿/* 
 * © Copyright 2013 by ScaleOut Software, Inc.
 *
 * LICENSE AND DISCLAIMER
 * ----------------------
 * This material contains sample programming source code ("Sample Code").
 * ScaleOut Software, Inc. (SSI) grants you a nonexclusive license to compile, 
 * link, run, display, reproduce, and prepare derivative works of 
 * this Sample Code.  The Sample Code has not been thoroughly
 * tested under all conditions.  SSI, therefore, does not guarantee
 * or imply its reliability, serviceability, or function. SSI
 * provides no support services for the Sample Code.
 *
 * All Sample Code contained herein is provided to you "AS IS" without
 * any warranties of any kind. THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGMENT ARE EXPRESSLY
 * DISCLAIMED.  SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED
 * WARRANTIES, SO THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO 
 * EVENT WILL SSI BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, 
 * SPECIAL OR OTHER CONSEQUENTIAL DAMAGES FOR ANY USE OF THE SAMPLE CODE
 * INCLUDING, WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS 
 * INTERRUPTION, LOSS OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION
 * HANDLING SYSTEM OR OTHERWISE, EVEN IF WE ARE EXPRESSLY ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGES.
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
    public enum PositionType { Core, Hedge }

    [Serializable]
    public class Position
    {
        [DisplayName("Position Type")]
        public PositionType PositionType { get; set; }
        [DisplayName("Ticker")]
        public string Ticker { get; set; }
        [DisplayName("Price")]
        public decimal Price { get; set; }
        [DisplayName("Position")]
        public decimal Shares { get; set; }
        [DisplayName("Target Allocation (%)")]
        public decimal TargetAllocationPercent { get; set; }
        [DisplayName("Actual Allocation (%)")]
        public decimal ActualAllocationPercent { get; set; }
        [DisplayName("Exposure")]
        public decimal Exposure
        {
            get { return this.Price * this.Shares; }
        }
        [DisplayName("Deviation (%)")]
        public decimal Deviation
        {
            get { return this.ActualAllocationPercent - this.TargetAllocationPercent; }
        }
        [DisplayName("Alert")]
        public bool Alerted { get; set; }
    }
}
